<template>
    <div class="module-options">
        <div @click="toggleOpen" class="option-icon">
            <app-icon icon="ellipsis-v"></app-icon>
        </div>
        <transition name="move-up">
            <div v-if="open" class="option-selection">
                <div class="close">
                    <app-icon @click="toggleOpen" icon="times-circle"></app-icon>
                </div>
                <ul class="options">
                    <li class="option-item" @click="openPopup">
                        <div class="icon">
                            <app-icon icon="trash-alt"></app-icon>
                        </div>
                        <div class="title">Delete Notebook</div>
                    </li>
                </ul>
            </div>
        </transition>
        <delete-notebook-popup
            :open="isPopUpOpen"
            :notebook="notebook"
            @open="closePopup"
            @confirmAction="performDelete"
        ></delete-notebook-popup>
    </div>
</template>

<style lang="css" scoped>
.move-up-enter-active,
.move-up-leave-active {
    transition: all 200ms cubic-bezier(0.4, 0, 0.2, 1);
}
.move-up-enter,
.move-up-leave-to {
    opacity: 0;
    transform: translateY(200px);
}
</style>

<script lang='ts'>
import Component, { mixins } from 'vue-class-component'
import DeleteNotebookPopup from '@/app/Editor/components/Notebook/primitives/DeleteNotebookPopup.vue'
import { ModuleOptionsMixin } from '@/app/Editor/components/mixins/ModuleOptions'
import { Prop } from 'vue-property-decorator'
import { INotebook } from '@/store/types/notebooks'
import { offlineDB } from '@/offline/db'

@Component({
    components: { DeleteNotebookPopup },
})
export default class NotebookOptions extends mixins(ModuleOptionsMixin) {
    // Props

    @Prop() notebook!: INotebook

    // Methods

    performDelete() {
        if (this.notebook) {
            const url = `/notebook/1111-7777-0000-1111`
            offlineDB.deleteNotebook(this.notebook).then(() => {
                if (this.$route.fullPath !== url) this.$router.push(url)
            })
        }
    }
}
</script>